//-------------------------------------------------------------------------------------------------------
//
// internes EEPROM
//
//-------------------------------------------------------------------------------------------------------


#include <avr/io.h>

#include "Error.h"
#include "Config.h"


//-------------------------------------------------------------------------------------------------------
// EEPROM beschreiben
void F_EEPROM_schreiben(uint8_t Adresse_H, uint8_t Adresse_L, uint8_t Wert)
{
	// warten auf Vollendung des vorherigen Schreibens
	while(EECR & (1<<EEPE));

	// Adresse und Daten in Register schreiben
	EEARH = Adresse_H;
	EEARL = Adresse_L;
	EEDR = Wert;

	// Master Programming enable
	EECR |= (1<<EEMPE);

	// EEPROM schreiben
	EECR |= (1<<EEPE);
}


//-------------------------------------------------------------------------------------------------------
// EEPROM auslesen
uint8_t F_EEPROM_lesen(uint8_t Adresse_H, uint8_t Adresse_L)
{
	// warten auf Vollendung des vorherigen Schreibens
	while(EECR & (1<<EEPE));
	
	// Adresse in Register schreiben
	EEARH = Adresse_H;
	EEARL = Adresse_L;

	// EEPROM lesen starten
	EECR |= (1<<EERE);

	return EEDR;
}